%% Initial clean up
close all;
clear all;
clc;

%% Paths and variables
pth_hand = 'hand.bmt';

%% Extract the hands using own setting of transformation
disp('Segmentation using empirically found settings. Press any key to continue...');
pause;

[BW_vis, BW_th, out_vis, out_th, dur_vis, dur_th] = extract_hands(pth_hand);

disp(['Time needed to segment VIS hand: ' num2str(dur_vis) ' s']);
disp(['Time needed to segment TH hand: ' num2str(dur_th) ' s']);

figure;
imagesc(BW_vis);
title('Binary mask of VIS hand');

figure;
imagesc(BW_th);
title('Binary mask of TH hand');

figure;
imshow(out_vis);
title('Segmented VIS hand');

figure;
imshow(out_th);
title('Segmented TH hand');

%% Extract the hands using image registration
disp('Segmentation using image registration. Press any key to continue...');
pause;

close all;

[BW_vis, BW_th, out_vis, out_th, dur_vis, dur_th] = seg_hands_using_reg(pth_hand, [], [], 'joint');

disp(['Time needed to segment VIS hand: ' num2str(dur_vis) ' s']);
disp(['Time needed to segment TH hand: ' num2str(dur_th) ' s']);

figure;
imagesc(BW_vis);
title('Binary mask of VIS hand');

figure;
imagesc(BW_th);
title('Binary mask of TH hand');

figure;
imshow(out_vis);
title('Segmented VIS hand');

figure;
imshow(out_th);
title('Segmented TH hand');